//+-------------------------------------------------------------------------+
//|       2011                                             TF_ABCD_v4.7.mq4 |
//| The author of idea & coding by Grein.                                   |  
//+-------------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 8

#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  Green
#property indicator_color4  Red
#property indicator_color5  Green
#property indicator_color6  Red
#property indicator_color7  Green
#property indicator_color8  Red

#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  1
#property indicator_width4  1
#property indicator_width5  1
#property indicator_width6  1
#property indicator_width7  1
#property indicator_width8  1

#property indicator_maximum 5
#property indicator_minimum 0


extern int     tf_A    = 2;  //   A,    1 
extern int     tf_B    = 3;  //   B,    1 
extern int     tf_C    = 5;  //   C,    1 
extern int     tf_D    = 7;  //   D,    1 

extern double  delta_A = 1;  //       A
extern double  delta_B = 2;  //       B
extern double  delta_C = 3;  //       C
extern double  delta_D = 5;  //       D

double tf_A_up[];
double tf_A_dn[];
double tf_B_up[];
double tf_B_dn[];
double tf_C_up[];
double tf_C_dn[];
double tf_D_up[];
double tf_D_dn[];

int init()
{
   IndicatorBuffers(8);
   
   SetIndexBuffer(0,tf_A_up);SetIndexStyle(0,DRAW_ARROW);SetIndexArrow(0,110);
   SetIndexBuffer(1,tf_A_dn);SetIndexStyle(1,DRAW_ARROW);SetIndexArrow(1,110);
   SetIndexBuffer(2,tf_B_up);SetIndexStyle(2,DRAW_ARROW);SetIndexArrow(2,110);
   SetIndexBuffer(3,tf_B_dn);SetIndexStyle(3,DRAW_ARROW);SetIndexArrow(3,110);
   SetIndexBuffer(4,tf_C_up);SetIndexStyle(4,DRAW_ARROW);SetIndexArrow(4,110);
   SetIndexBuffer(5,tf_C_dn);SetIndexStyle(5,DRAW_ARROW);SetIndexArrow(5,110);
   SetIndexBuffer(6,tf_D_up);SetIndexStyle(6,DRAW_ARROW);SetIndexArrow(6,110);
   SetIndexBuffer(7,tf_D_dn);SetIndexStyle(7,DRAW_ARROW);SetIndexArrow(7,110);
 
   IndicatorShortName("TF_ABCD_v4.7 = "+tf_A+"  "+tf_B+"  "+tf_C+"  "+tf_D);
   return(0);
}
int deinit(){ return(0);}
int start()
 {
   int  counted_bars=IndicatorCounted();
   int  i,limit;
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   for(i=limit;i>=0;i--)
   {
      tf_A_up[i] = EMPTY_VALUE; tf_A_dn[i] = EMPTY_VALUE;
      tf_B_up[i] = EMPTY_VALUE; tf_B_dn[i] = EMPTY_VALUE;
      tf_C_up[i] = EMPTY_VALUE; tf_C_dn[i] = EMPTY_VALUE;
      tf_D_up[i] = EMPTY_VALUE; tf_D_dn[i] = EMPTY_VALUE;
               
      if(NormalizeDouble((Close[i]-Close[i+tf_A])*MathPow(10,Digits),Digits)>=delta_A)  tf_A_up[i] = 1;
      if(NormalizeDouble((Close[i+tf_A]-Close[i])*MathPow(10,Digits),Digits)>=delta_A)  tf_A_dn[i] = 1;
      
      if(NormalizeDouble((Close[i]-Close[i+tf_B])*MathPow(10,Digits),Digits)>=delta_B)  tf_B_up[i] = 2;
      if(NormalizeDouble((Close[i+tf_B]-Close[i])*MathPow(10,Digits),Digits)>=delta_B)  tf_B_dn[i] = 2;
            
      if(NormalizeDouble((Close[i]-Close[i+tf_C])*MathPow(10,Digits),Digits)>=delta_C)  tf_C_up[i] = 3;
      if(NormalizeDouble((Close[i+tf_C]-Close[i])*MathPow(10,Digits),Digits)>=delta_C)  tf_C_dn[i] = 3;
            
      if(NormalizeDouble((Close[i]-Close[i+tf_D])*MathPow(10,Digits),Digits)>=delta_D)  tf_D_up[i] = 4;
      if(NormalizeDouble((Close[i+tf_D]-Close[i])*MathPow(10,Digits),Digits)>=delta_D)  tf_D_dn[i] = 4;                
   }

   return(0);
}
//-------------------------------------------------------------------------------------------------------------

      